//+------------------------------------------------------------------+
//| Hedge_Close.mq4
//+------------------------------------------------------------------+

extern string Symbol_2         =  "";          //Druh mnov pr
extern double ProfitInCash     =  3000.0;      //Zisk pro zaven pozic v mn Metatraderu (zde CZK) 
extern double LossInCash       =  -2000.0;     //Ztrta pro zaven pozic v mn Metatraderu (zde CZK)
extern string MagicComment     =  "";     //Koment u obchod, kter budou touto ea zeny    
extern int    PairDif          =  5;           //Hodnota rozdlu od nuly pro indiktor Neutral Hedge, kdy se zavou pozice
extern int    moreBars         =  0;           //Poet bar, kter jsou mimo viditelnou oblast grafu
extern int    TF_Hedge         =  15;          //Time frame indiktoru Neutral Hedge
extern bool   Mirroring        =  false;       //Pepna smru korelace indiktoru Neutral Hedge
extern int    Slippage         =  3;

int MaxTries = 10;

int closeTrade(string Symbol_Close)
{
   int   lastError;

   for(int j = OrdersTotal()-1; j>=0; j--)  
   {
      if (OrderSelect(j, SELECT_BY_POS)==false) continue;
      if (OrderSymbol()==Symbol_Close && OrderComment()==MagicComment)
      {
         for (int i = 0; i < MaxTries; i++)
         {
            lastError = 0;
            OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage,Red); 
            lastError = GetLastError();
            if (0 != lastError)
            {
               if (lastError ==   4 || // ERR_SERVER_BUSY
                   lastError == 135 || // ERR_PRICE_CHANGED
                   lastError == 136 || // ERR_OFF_QUOTES
                   lastError == 137 || // ERR_BROKER_BUSY
                   lastError == 146)   // ERR_TRADE_CONTEXT_BUSY
               {
                  if (lastError == 135) RefreshRates();
                  else                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  Alert(Symbol() + ", Error = "       + DoubleToStr(lastError,0) 
                                 + ", Close price = " + DoubleToStr(OrderClosePrice(),Digits));
               }  
            }
            else return (1);
         }   
      }   
   }   
      
   return (0);
}

int start()
{
   int    ticket         = 0;
   int    OpenOrders     = 0;
   double ProfitSymbol_1 = 0;
   double ProfitSymbol_2 = 0;
   double LossSymbol_1   = 0;
   double LossSymbol_2   = 0;
   int    TicketSymbol_1 = 0;
   int    TicketSymbol_2 = 0;
   int    Close_Return   = 1;
   string OC             = "";
   string MC             = MagicComment;
   
   double HedgeDn=iCustom(NULL, TF_Hedge, "NeutralHedge",Symbol_2,moreBars,Mirroring,0,0);
   double HedgeUp=iCustom(NULL, TF_Hedge, "NeutralHedge",Symbol_2,moreBars,Mirroring,1,0);
   
   int totalOrders = OrdersTotal();
   if (totalOrders < 1 ) return (0);

   for (int i = 0; i < totalOrders;i++)
   {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) continue;
      if (OrderComment()==MagicComment)
      {
         OC = MagicComment;
         if (OrderSymbol()==Symbol())
         {
            if (OrderType()==OP_BUY || OrderType()==OP_SELL)
            {
               ProfitSymbol_1 += OrderProfit();
               TicketSymbol_1  = OrderTicket();
            }  
         }
         if (OrderSymbol()==Symbol_2)
         {
            if (OrderType()==OP_BUY || OrderType()==OP_SELL)
            {
               ProfitSymbol_2 += OrderProfit();
               TicketSymbol_2  = OrderTicket();
            }  
         }
         if (ProfitSymbol_1 + ProfitSymbol_2 >= ProfitInCash ||
             ProfitSymbol_1 + ProfitSymbol_2 <= LossInCash ||
             (HedgeUp<=PairDif && HedgeDn>=-PairDif))  
             
         {
            if (TicketSymbol_1 > 0 && TicketSymbol_2 > 0)
            {
               Close_Return = closeTrade(Symbol());
               Close_Return = closeTrade(Symbol_2);
            }   
         }   
      }   
   }
   
   if (StringLen(OC)<1) OC = "<Empty>";
   if (StringLen(MC)<1) MC = "<Empty>";
   
   Comment("\n\nSymbol 1 = " + Symbol() +
           "\nSymbol 2 = " + Symbol_2 +
           "\nKoment u obchod = " + OC +
           "\nKoment v AOS = " + MC +
           "\nTake Profit = " + DoubleToStr(ProfitInCash,2) + " " + AccountCurrency()  +
           "\nStopLoss = " + DoubleToStr(LossInCash,2) + " " + AccountCurrency() +
           "\nZisk/Ztrta =  " + DoubleToStr(ProfitSymbol_1+ProfitSymbol_2,2) + " " + AccountCurrency() +  
           "\nHedgeUp = " + DoubleToStr(HedgeUp,0)+
           "\nHedgeDn = " + DoubleToStr(HedgeDn,0) 
           );

   return (0);
}
           